# Поиск, сортировка ("Университет")
## Поиск
```
<Window x:Class="University.MainWindow"
        xmlns="http://schemas.microsoft.com/winfx/2006/xaml/presentation"
        xmlns:x="http://schemas.microsoft.com/winfx/2006/xaml"
        xmlns:d="http://schemas.microsoft.com/expression/blend/2008"
        xmlns:mc="http://schemas.openxmlformats.org/markup-compatibility/2006"
        xmlns:local="clr-namespace:University"
        mc:Ignorable="d"
        Title="University" Height="450" Width="800">
	<Grid>
		<Grid.RowDefinitions>
			<RowDefinition Height="Auto" />
			<RowDefinition Height="*" />
		</Grid.RowDefinitions>

		<StackPanel Orientation="Horizontal" Margin="10">

            <Label 
Content="искать" 
VerticalAlignment="Center"/>
            <TextBox
Width="200"
VerticalAlignment="Center"
x:Name="SearchFilterTextBox" 
KeyUp="SearchFilter_KeyUp"/>
            <Label
    Content="Возраст:"
    VerticalAlignment="Center"/>
			<RadioButton
				GroupName="Age"
				Tag="1"
				Content="по возрастанию"
				IsChecked="True"
				Checked="RadioButton_Checked"
				VerticalAlignment="Center"/>
            <RadioButton
				GroupName="Age"
				Tag="2"
				Content="по убыванию"
				Checked="RadioButton_Checked"
				VerticalAlignment="Center"/>
        </StackPanel>

		<ListView x:Name="StudentListView" Grid.Row="1" Margin="10">
			<ListView.View>
				<GridView>
					<GridViewColumn Header="Имя" DisplayMemberBinding="{Binding Name}" />
					<GridViewColumn Header="Курс" DisplayMemberBinding="{Binding Course}" />
					<GridViewColumn Header="Национальность" DisplayMemberBinding="{Binding Nationality}" />
					<GridViewColumn Header="Возраст" DisplayMemberBinding="{Binding Age}" />
				</GridView>
			</ListView.View>
		</ListView>
	</Grid>
</Window>
```
```
using System;
using System.Collections.Generic;
using System.Linq;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Input;

namespace University
{
    public partial class MainWindow : Window
    {
        private List<Student> students;
        private string searchFilter = "";
        private bool sortAsc = true;

        public MainWindow()
        {
            InitializeComponent();

            // Инициализируем список студентов
            InitializeData();

            // Отображаем всех студентов в listview
            UpdateStudentList(students);
        }
        private void SearchFilter_KeyUp(object sender, KeyEventArgs e)
        {
            searchFilter = SearchFilterTextBox.Text;
            Invalidate();
        }

        private void Invalidate()
        {
            throw new NotImplementedException();
        }

        private void InitializeData()
        {
            // Создаем список студентов
            students = new List<Student>
            {
                new Student { Name = "Джейк Ли", Course = 1, Nationality = "Китаец", Age = 19 },
                new Student { Name = "Ариадна Санчес", Course = 2, Nationality = "Испанец", Age = 20 },
                new Student { Name = "Эдвард Каллен", Course = 1, Nationality = "Американец", Age = 20 },
                new Student { Name = "Эндрю Уилсон", Course = 3, Nationality = "Американец", Age = 21 },
                new Student { Name = "Хэй Вэнь", Course = 3, Nationality = "Китаец", Age = 22 },
                new Student { Name = "Семен Хомяк", Course = 4, Nationality = "Русский", Age = 23 },
            };
        }

        private void FilterComboBox_SelectionChanged(object sender, SelectionChangedEventArgs e)
        {
            List<Student> filteredStudents = new List<Student>();

            // Фильтруем список студентов по выбранному критерию

            UpdateStudentList(filteredStudents);
        }

        private void UpdateStudentList(List<Student> studentsToDisplay)
        {
            StudentListView.ItemsSource = studentsToDisplay;
        }

        private void RadioButton_Checked(object sender, RoutedEventArgs e)
        {
            sortAsc = (sender as RadioButton).Tag.ToString() == "1";
            InvalidateVisual(); // Исправлено имя метода
        }

        private void SortByAgeButton_Click(object sender, RoutedEventArgs e)
        {
            // Сортируем список студентов по возрасту
            List<Student> sortedStudents = students.OrderBy(student => student.Age).ToList();

            // Если нужно отсортировать по убыванию, разворачиваем список
            if (!sortAsc)
            {
                sortedStudents.Reverse();
            }

            // Обновляем список студентов в ListView
            UpdateStudentList(sortedStudents);
        }

        private IEnumerable<Student> FilteredStudentList
        {
            get
            {
                // сохраняем во временную переменную полный список
                var res = students;

                return res;
            }
        }
    }

    class Student
    {
        public string Name { get; set; }
        public int Course { get; set; }
        public string Nationality { get; set; }
        public int Age { get; set; }
    }
}
```
![](./img/Снимок%20экрана%202024-04-29%20083601.png)